// EMD_TRIANG.M
//
// P. Flandrin, Mar. 13, 2003 - modified Mar. 2, 2006
//  H. Nahrstaedt - Aug 2010
//
clc;  h=scf(); fig_id=get(gcf(),"figure_id"); clf; mode(1);lines(0);
// computes and displays EMD for the sum of 2 triangular 
// waveforms + 1 tone 
//
// produces Figure 2 in
//
// G. Rilling, P. Flandrin and P. Gonalvs
// "On Empirical Mode Decomposition and its algorithms"
// IEEE-EURASIP Workshop on Nonlinear Signal and Image Processing
// NSIP-03, Grado (I), June 2003
mode(-1)
warning("This demo needs the Time Frequency Toolbox!");
N = 1024;// # of data samples
t = 1:N;
demopath = get_absolute_file_path("emd_triang.sce");
exec(demopath+"triangular_signal.sci",-1);
// triangular waveform 1
p1 = fix(N/6);// period
x1 = triangular_signal(N,p1);

// tone
f0 = 0.03;// frequency
x2 = real(fmconst(N,f0));

// triangular waveform 2
p3 = 5;// period
x3 = triangular_signal(N,p3);

x = x1 + 0.4*x2' + .4*x3;

[imf,ort,nbits] = emd(x);

emd_visu(t,x,imf,'all',fig_id);

